import {
  axisLeft,
  axisBottom,
  scaleLinear,
  extent,
  scaleTime,
  line,
  curveBasis
} from 'd3'; 

export const lineChart = (selection, props) => {
  
    const {
      data,
      colorValue,
      colorScale,
      selectedColorValue,
      width,
      height,
      margin,
      title,
      xValue,
      xAxisLabel,
      yValue,
      yAxisLabel, 
      circleRadius,
      innerWidth,
      innerHeight
  } = props;
  
  console.log(title);
  
  
  /*const g = selection.selectAll('.container').data([null]);
  const gEnter = g
    .enter().append('g')
      .attr('class', 'container');
  gEnter
    .merge(g)
      .attr('transform',
        `translate(${margin.left},${margin.top})`
      )
    .append('text')
      .attr('class', 'title')
      .attr('y', -10)
      .text(title);*/
  
  const g = selection.selectAll('.container').data([null]);
  const gEnter = g
    .enter().append('g')
      .attr('class', 'container');
  gEnter
    .merge(g)
      .attr('transform',
        `translate(${margin.left},${margin.top})`
      )
  
  gEnter.append('text')
    .merge(g.select('.title'))
      .attr('class', 'title')
      .attr('y', -10)
      .text(title);
  
  
   /*const xScale = scaleLinear()
    .domain(extent(data, xValue))
    .range([0, innerWidth])
    .nice();*/
  const xScale = scaleTime()
    .domain(extent(data, xValue))
    .range([0, innerWidth])
    .nice();
  
  const yScale = scaleLinear()
    .domain(extent(data, yValue))
    .range([innerHeight, 0])
    .nice();
  
 /* const g = svg.append('g')
    .attr('transform', `translate(${margin.left},${margin.top})`);
 */ 
  const xAxis = axisBottom(xScale)
    .tickSize(-innerHeight)
    .tickPadding(15);
  
  const yAxis = axisLeft(yScale)
    .tickSize(-innerWidth)
    .tickPadding(10);
  
  /*const gUpdate = selection.selectAll('g').data([null]);  
  const gEnter = gUpdate.enter().append('g')
  const g = gUpdate.merge(gEnter); */
  
  const yAxisG = g.select('.y-axis');
  const yAxisGEnter = gEnter
    .append('g')
      .attr('class', 'y-axis');
  
  yAxisG.merge(yAxisGEnter)
      .call(yAxis)
    .selectAll('.domain').remove();

  yAxisGEnter.append('text')
    .attr('class', 'axis-label')
    .attr('y', -73)
    .attr('fill', 'black')
    .attr('transform', `rotate(-90)`)
    .attr('text-anchor', 'middle')
  .merge(yAxisG.select('.axis-label'))
    .attr('x', -innerHeight / 2)
    .text(yAxisLabel);
  
    
  const xAxisG = g.select('.x-axis');
  const xAxisGEnter = gEnter
    .append('g')
      .attr('class', 'x-axis');
  
  xAxisG
    .merge(xAxisGEnter)
      .attr('transform', `translate(0,${innerHeight})`)
      .call(xAxis)
      .selectAll('domain').remove();
  
  xAxisGEnter.append('text')
    .attr('class', 'axis-label')
    .attr('y', 75)
    .attr('fill', 'black')
  .merge(xAxisG.select('.axis-label'))
    .attr('x', innerWidth / 2)
    .text(xAxisLabel);
  
  

//////////////////line stuff

  const lineGenerator = line()
    .x(d => xScale(xValue(d)))
    .y(d => yScale(yValue(d)))
    .curve(curveBasis);
  
  /*g.append('path')
      .attr('class', 'line-path')
      .attr('d', lineGenerator(data));*/
  
////////////  
  console.log(xValue);
  let dataline = gEnter
    .append('path')
      .attr('class', 'dataline')
    .merge(g.select('dataline'))
      .attr('d', lineGenerator(data));
  
  
////////////////circle stuff
  /*
  let datapoints = g.merge(gEnter)
    .selectAll('circle').data(data);

  
  let datapointsEnter = datapoints
    .enter().append('circle')
      .attr('class','datapoints')
      .attr('cy', d => yScale(yValue(d)))
      .attr('cx', d => xScale(xValue(d)))
      .attr('r', circleRadius)
      .attr('fill',d => colorScale(colorValue(d)))
    .merge(datapoints)
    .transition().duration(1500)
      .delay((d,i) => i *10)
      .attr('cy', d => yScale(yValue(d)))
      .attr('cx', d => xScale(xValue(d)))
      .attr('r', circleRadius);
  

  
  datapoints 
    .merge(datapointsEnter) 
      .attr('opacity',d =>
         (!selectedColorValue) || (selectedColorValue == colorValue(d))
              ? 1
              : 0.25
        )
     .classed('highlighted', d => 
       selectedColorValue && selectedColorValue === colorValue(d)) 
       */
}